NumericConversions: trait
  includes Natural, Integer, Positive
  introduces
    nat2int: Nat -> Int
    pos2int: Pos -> Int
    int2nat: Int -> Nat
    pos2nat: Pos -> Nat
    int2pos: Int -> Pos
    nat2pos: Nat -> Pos
  asserts with n: Nat, i: Int, p: Pos
    int2nat(0:Int) = 0;
    int2pos(1:Int) = 1;
    nat2int(0:Nat) = 0;
    nat2pos(1:Nat) = 1;
    pos2int(1:Pos) = 1;
    pos2nat(1:Pos) = 1;
    nat2int(succ(n)) = succ(nat2int(n));
    pos2int(succ(p)) = succ(pos2int(p));
    pos2nat(succ(p)) = succ(pos2nat(p));
    0 <= i => int2nat(succ(i)) = succ(int2nat(i));
    0 < i => int2pos(succ(i)) = succ(int2pos(i));
    0 < n => nat2pos(succ(n)) = succ(nat2pos(n));
  implies with n: Nat, p: Pos
    0 < pos2nat(p);
    pos2nat(p) ~= 0;
    pos2nat(nat2pos(succ(n))) = succ(n);
    nat2pos(pos2nat(p)) = p
