% This specification is for documentation only.  It is not used in any proof.
% See AutomatonAEnv.lsl, etc., instead.

AutomatonEnv: trait
  includes Array(I, Bool), Integer, IOAutomaton(Env)
  introduces
    OK, requestBalance:  I                           -> Actions[Env]
    reportBalance,
      requestDeposit,
      requestWithdrawal: Int, I                      -> Actions[Env]
    __.active:           States[Env]                 -> Array[I, Bool]
    almostsame:          States[Env], States[Env], I -> Bool
  asserts with i, j: I, n: Int, s, s': States[Env]
   sort Actions[Env] generated freely by
        OK, reportBalance, requestDeposit, requestWithdrawal, requestBalance;
        % This does not take account of the "where n > 0" clause

     isInput(OK(i));
     isInput(reportBalance(n, i));
     isOutput(requestDeposit(n, i));
     isOutput(requestWithdrawal(n, i));
     isOutput(requestBalance(i));

     almostsame(s, s', i) <=> \A j (j ~= i => s'.active[j] = s.active[j]);

     start(s) <=> s.active = constant(false);

     effect(s, OK(i), s') 
       <=> s'.active[i] = false /\ almostsame(s, s', i);

     effect(s, reportBalance(n, i), s')
       <=> s'.active[i] = false /\ almostsame(s, s', i);

     enabled(s, requestDeposit(n, i)) 
       <=> ~s.active[i];
     effect(s, requestDeposit(n, i), s') 
       <=> s'.active[i] /\ almostsame(s, s', i);

     enabled(s, requestWithdrawal(n, i)) 
       <=> ~s.active[i];
     effect(s, requestWithdrawal(n, i), s') 
       <=> s'.active[i] /\ almostsame(s, s', i);

     enabled(s, requestBalance(i)) 
       <=> ~s.active[i];
     effect(s, requestBalance(i), s') 
       <=> s'.active[i] /\ almostsame(s, s', i);
