InvariantCEnv1: trait
  includes AutomatonCEnv
  introduces 
    inv2, inv11, inv12, inv13, inv14, 
    inv15, inv12to15: States[CEnv] -> Bool
  asserts with s: States[CEnv], i, j: I, m, m1, m2: Set[OpRec1], 
               mseq: Seq[Msg], msg1, msg2: Msg, s1, s2: String, n: Int,
               b, b1: BalRec1, x, y: OpRec1

    inv2(s) <=>
        \A x:OpRec1 (      x \in ((s.C)[x.location]).ops
                        /\ ~((x.seqno) \in ((s.C)[x.location]).reports)
                     =>    s.active[x.location]

                        /\ \A y:OpRec1 (   y \in ((s.C)[y.location]).ops
                                        /\ x.location = y.location
                                        /\ ~((y.seqno) \in 
                                             ((s.C)[y.location]).reports)
                                   => x:OpRec1 = y)
                        /\ ((s.C)[x.location]).bals = {})
     /\ \A b:BalRec1 \A i:I 
           (b \in ((s.C)[i]).bals 
               =>   s.active[i]
                  /\ \A b1:BalRec1 (b1 \in ((s.C)[i]).bals => b = b1));

     % No messages are sent from i to i.

     inv11(s) <=> \A i:I (   s.queue[i, i] = {}     
                          /\ ~((s.C)[i]).reqSent[i]
                          /\ ~((s.C)[i]).reqRcvd[i] 
                          /\ ~((s.C)[i]).respRcvd[i]);

     % If there is a request message in channel(i, j), then i has an 
     % outstanding balance request, i has sent a request to j, j has not
     % received a request from i, there is no other request message in
     % channel(i, j), there is no Set[OpRec1] message in channel(j, i), and i 
     % has not received a response from j.

     inv12(s) <=>
       \A i:I \A j:I \A s1:String (req(s1) \in s.queue[i, j] 
            =>    [null] \in ((s.C)[i]).bals
               /\ ((s.C)[i]).reqSent[j]
               /\ ~((s.C)[j]).reqRcvd[i]
               /\ (s.queue[i, j] = {req(s1)} \/
                   \E m:Set[OpRec1] (s.queue[i, j] = {req(s1)} |- set(m) \/
                                     s.queue[i, j] = {set(m)} |- req(s1)))
               /\ ~\E m:Set[OpRec1] (set(m) \in s.queue[j, i])
               /\ ~((s.C)[i]).respRcvd[j]);

     % If j has received a request from i, then i has an outstanding balance
     % request, i has sent a request to j, and i has not received a response 
     % from j.
	
     inv13(s) <=>
       \A i:I \A j:I (((s.C)[j]).reqRcvd[i]
            =>    [null] \in ((s.C)[i]).bals
               /\ ((s.C)[i]).reqSent[j]
               /\ ~((s.C)[i]).respRcvd[j]);

     % If there is a Set[OpRec1] message in channel(j, i), then i has an
     % outstanding balance request, i has sent a request to j, j does not have
     % a current request from i, there is no other Set[OpRec1] message in
     % channel(j, i), there is no request message in channel(i, j), and i
     % has not received a response from j.

     inv14(s) <=>
       \A i:I \A j:I \A m:Set[OpRec1] (set(m) \in s.queue[j, i] 
            =>    [null] \in ((s.C)[i]).bals
               /\ ((s.C)[i]).reqSent[j]
               /\ ~((s.C)[j]).reqRcvd[i]
               /\ (s.queue[j, i] = {set(m)} \/
                   \E s1:String (s.queue[j, i] = {req(s1)} |- set(m) \/
                                 s.queue[j, i] = {set(m)} |- req(s1)))
               /\ ~\E s1:String (req(s1) \in s.queue[i, j])
               /\ ~((s.C)[i]).respRcvd[j]);

     % If i has received a response from j, then i has sent a request to j.

     inv15(s) <=>
       \A i:I \A j:I (((s.C)[i]).respRcvd[j] => ((s.C)[i]).reqSent[j]);

     inv12to15(s) <=> inv12(s) /\ inv13(s) /\ inv14(s) /\ inv15(s);

  implies InductiveInv(CEnv, inv11), InductiveInv(CEnv, inv12to15)
