InvariantAEnv: trait
  includes AutomatonAEnv
  introduces inv, inv1, inv2, inv3, inv4: States[AEnv] -> Bool
  asserts with b, b1: BalRec, x, y, z: OpRec, i: I, k: Pos, s: States[AEnv]
    inv1(s) <=>
        \A x:OpRec (x \in s.ops /\ ~x.reported =>
                       s.active[x.location]
                    /\ \A y:OpRec (y \in s.ops /\ x.location = y.location
                                   /\ ~y.reported => x:OpRec = y)
                    /\ \A b:BalRec (b \in s.bals => x.location ~= b.location))
      /\ \A b:BalRec (b \in s.bals => 
                         s.active[b.location]
                      /\ \A b1:BalRec (b1 \in s.bals 
                                       /\ b.location = b1.location => b = b1));
    inv2(s) <=>
      \A x:OpRec (x \in s.ops => pos2nat(x.seqno) <= s.lastSeqno[x.location]);
    inv3(s) <=>
      \A i:I \A k:Pos (pos2nat(k) <= s.lastSeqno[i] 
                             => \E z:OpRec (z \in s.ops /\ z.location = i
                                            /\ z.seqno = k));
    inv4(s) <=> 
      \A x:OpRec \A y:OpRec(
          x \in s.ops /\ y \in s.ops /\ x.location = y.location 
              /\ x.seqno = y.seqno => x:OpRec = y);
    inv(s) <=> inv1(s) /\ inv2(s) /\ inv3(s) /\ inv4(s)
%  implies traits InductiveInv(AEnv, inv)
  implies InductiveInv(AEnv, inv1), InductiveInv(AEnv, inv2),
          InductiveInv(AEnv, inv3), InductiveInv(AEnv, inv4)