InvariantCEnv: trait
  includes AutomatonCEnv
  introduces 
    inv, inv1, inv2, inv3, inv4, inv5, inv6a, inv6b, inv7, 
    inv8, inv9: States[CEnv] -> Bool
  asserts with b, b1: BalRec1, x, y, z: OpRec1, k: Pos, s: States[CEnv],
               i, j: I, m: Set[OpRec1]

    inv1(s) <=>
        \A x:OpRec1 \A i:I (x \in ((s.C)[i]).ops 
                              => x \in ((s.C)[x.location]).ops);
    inv2(s) <=>
        \A x:OpRec1 (      x \in ((s.C)[x.location]).ops
                        /\ ~((x.seqno) \in ((s.C)[x.location]).reports)
                     =>    s.active[x.location]

                        /\ \A y:OpRec1 (   y \in ((s.C)[y.location]).ops
                                        /\ x.location = y.location
                                        /\ ~((y.seqno) \in 
                                             ((s.C)[y.location]).reports)
                                   => x:OpRec1 = y)
                        /\ ((s.C)[x.location]).bals = {})
     /\ \A b:BalRec1 \A i:I 
           (b \in ((s.C)[i]).bals 
               =>   s.active[i]
                  /\ \A b1:BalRec1 (b1 \in ((s.C)[i]).bals => b = b1));

    inv3(s) <=>
      \A x:OpRec1 (x \in ((s.C)[x.location]).ops =>
                     pos2nat(x.seqno) <= ((s.C)[x.location]).lastSeqno);

    inv4(s) <=>
      \A i:I \A k:Pos (pos2nat(k) <= ((s.C)[i]).lastSeqno
                         => \E z:OpRec1 (   z \in ((s.C)[i]).ops
                                         /\ z.location = i /\ z.seqno = k));
    inv5(s) <=> 
      \A x:OpRec1 \A y:OpRec1(
             x \in ((s.C)[x.location]).ops
          /\ y \in ((s.C)[y.location]).ops
          /\ x.location = y.location 
          /\ x.seqno = y.seqno 
          => x:OpRec1 = y);

    inv6a(s) <=>
      \A i: I \A j: I  \A x: OpRec1 (
               [null] \in ((s.C)[i]).bals /\ x \in s.mustInclude[i] 
            /\ x.location = j /\ j ~= i 
         =>
               x \in ((s.C)[j]).ops 
            /\ \A m: Set[OpRec1] (set(m) \in s.queue[j, i] => x \in m)
            /\ ((((s.C)[i]).respRcvd)[j] => x \in ((s.C)[i]).ops));

    inv6b(s) <=>
      \A x: OpRec1 (
               [null] \in ((s.C)[x:OpRec1.location]).bals 
            /\ x:OpRec1 \in s.mustInclude[x:OpRec1.location] 
         =>
               x:OpRec1 \in ((s.C)[x:OpRec1.location]).ops);

     inv7(s) <=>
       \A x:OpRec1 \A i:I \A j:I \A m:Set[OpRec1] (
           x \in m /\ set(m) \in s.queue[i, j] 
              => x \in ((s.C)[x:OpRec1.location]).ops);

     inv8(s) <=>
       \A x:OpRec1 \A i:I (x:OpRec1 \in s.mustInclude[i] 
            => (x:OpRec1.seqno) \in ((s.C)[x:OpRec1.location]).reports);

     % Needed for requestDeposit case of simulation
     inv9(s) <=>
       \A i:I \A k:Pos (k \in ((s.C)[i]).reports 
                          => pos2nat(k) <= ((s.C)[i]).lastSeqno);

%     inv(s) <=>   inv1(s) /\ inv2(s) /\ inv3(s) /\ inv4(s) /\ inv5(s)
%               /\ inv6a(s) /\ inv6b(s) /\ inv7(s) /\ inv8(s) /\ inv9(s);
     inv(s) <=>   inv1(s) /\ inv2(s) /\ inv3(s) /\ inv5(s)
               /\ inv6a(s) /\ inv6b(s) /\ inv7(s) /\ inv8(s) /\ inv9(s);

  implies InductiveInv(CEnv, inv1),
          InductiveInv(CEnv, inv2),
	  InductiveInv(CEnv, inv3),
	  InductiveInv(CEnv, inv4),
	  InductiveInv(CEnv, inv5),
          InductiveInv(CEnv, inv6a),
          InductiveInv(CEnv, inv6b),
          InductiveInv(CEnv, inv7),
          InductiveInv(CEnv, inv8),
          InductiveInv(CEnv, inv9)


