Sequence(E): trait
  includes Integer
  introduces
    {}:                        -> Seq[E]     % empty sequence
    {__}:       E              -> Seq[E]     % single element sequence
    __|-__:     Seq[E], E      -> Seq[E]     % append element
%   __-|__:     E, Seq[E]      -> Seq[E]     % prepend element
%   __||__:     Seq[E], Seq[E] -> Seq[E]     % concatenation
    __\in __:   E, Seq[E]      -> Bool       % "is element of"
    head, last: Seq[E]         -> E          % first, last element
    tail, init: Seq[E]         -> Seq[E]     % all but first, last elements
    len:        Seq[E]         -> Int        % length
%   __[__]:     Seq[E], Int    -> E          % element
  asserts
    Seq[E] generated by {}, |-                     % freely
    with e, e1, e2: E, s, s1, s2: Seq[E], n: Int
%     e -| {} = {} |- e;
%     (e1 -| s) |- e2 = e1 -| (s |- e2);
%     s || {} = s;
%     s1 || (s2 |- e) = (s1 || s2) |- e;
      {e} = {} |- e;
      ~(e \in {});
      e \in (s |- e1) <=> (e \in s) \/ e = e1;
      head(s |- e) = (if s = {} then e else head(s));
      tail(s |- e) = (if s = {} then {} else tail(s) |- e);
%     init(s |- e) = s;
%     last(s |- e) = e;
      len({}) = 0;
      len(s |- e) = succ(len(s));
%     s[0] = head(s);
%     n >= 0 => s[n+1] = tail(s)[n]
   implies
%    sort Seq[E] generated by {}, -|:E,Seq[E]->Seq[E]
     with e, e1, e2: E, s, s1, s2, s3: Seq[E]
%      e -| s ~= {};
       s |- e ~= {};
%      head(e -| s) = e;
%      tail(e -| s) = s;
%      s ~= {} => s = head(s) -| tail(s);
%      s ~= {} => s = init(s) |- last(s);
%      e \in (e1 -| s) <=> (e \in s) \/ e = e1;
%      e \in (e -| s);
       s ~= {} => head(s) \in s /\ last(s) \in s;
       s ~= {} /\ tail(s) ~= {} /\ e \in tail(s) => e \in s
