Process: trait
  includes 
    IOAutomaton(A),
    Natural(Nat),                                     % Process indices
    Set(Nat),
    Array1(Nat3, Nat),
    Array1(processState, Nat)
  Nat3 enumeration of 0, 1, 2
  processState tuple of 
   pc: pcValues, pcJ: Nat, S: Set[Nat]
  States[A] tuple of 
    turn: Nat, flag: Array[Nat, Nat3],                % Shared variables
    p: Array[Nat, processState]		              % Array of process states
  introduces
    n: -> Nat
    setPC: States[A], Nat, pcValues, States[A] -> Bool
    setPCj: States[A], Nat, Nat, States[A] -> Bool
    setS: States[A], Nat, Set[Nat], States[A] -> Bool
    setFlag: States[A], Nat, Nat3, States[A] -> Bool
    sameTurn, sameFlag, samePC, samePCj, sameS: States[A], States[A] -> Bool
    % Actions (input)
    try, exit: Nat -> Actions[A]
    % Actions (output)
    crit, rem: Nat -> Actions[A]
    % Actions (internal)
    setFlag1, testTurn, setTurn, setFlag2, reset: Nat -> Actions[A]
    testFlag, check: Nat, Nat -> Actions[A]
    % States
    rem, setFlag1, testTurn, testFlag, setTurn, setFlag2, 
      check, leaveTry, crit, reset, leaveExit: -> pcValues
    % Invariants
    mutex, assertion2, assertion3, assertion4, inv: States[A] -> Bool
    % Index of processes
    pindex: Nat -> Bool
  asserts
    pcValues generated freely by rem, setFlag1, testTurn, testFlag, setTurn, 
      setFlag2, check, leaveTry, crit, reset, leaveExit
  asserts
    Actions[A] generated freely by try, exit, crit, rem, setFlag1, testTurn,
      setTurn, setFlag2, reset, testFlag, check
  asserts with i, j, k: Nat, p: pcValues, n3: Nat3, x: Set[Nat], 
               s, s': States[A]
    % Axioms about actions
    isInput(try(i));
    isInput(exit(i));
    isOutput(crit(i));
    isOutput(rem(i));
    isInternal(setFlag1(i));
    isInternal(testTurn(i));
    isInternal(setTurn(i));
    isInternal(setFlag2(i));
    isInternal(reset(i));
    isInternal(testFlag(i, j));
    isInternal(check(i, j));
    % Axioms about initial state
    start(s) <=> \A i (s.flag[i] = 0 /\ (s.p[i]).pc = rem /\ (s.p[i]).S = {});
    % "Unchanged" predicates
    samePC(s, s') <=> 
        \A j ((s'.p[j]).pc = (s.p[j]).pc);
    samePCj(s, s') <=> 
        \A j ((s'.p[j]).pcJ = (s.p[j]).pcJ);
    sameS(s, s') <=> 
        \A j ((s'.p[j]).S = (s.p[j]).S);
    setPC(s, i, p, s') <=> 
        (s'.p[i]).pc = p /\ \A j (j ~= i => (s'.p[j]).pc = (s.p[j]).pc);
    setPCj(s, i, k, s') <=> 
        (s'.p[i]).pcJ = k /\ \A j (j ~= i => (s'.p[j]).pcJ = (s.p[j]).pcJ);
    setS(s, i, x, s') <=>
        (s'.p[i]).S = x /\ \A j (j ~= i => (s'.p[j]).S = (s.p[j]).S);
    setFlag(s, i, n3, s') <=>
       s'.flag[i] = n3/\ \A j (j ~= i => s'.flag[j] = s.flag[j]);
    % Axioms about transitions
    pindex(i) <=> 1 <= i /\i <= n;
    enabled(s, try(i)) <=> 
        pindex(i);
    effect(s, try(i), s') <=> 
           setPC(s, i, setFlag1, s')
        /\ sameS(s, s')
        /\ samePCj(s, s')
        /\ s'.turn = s.turn
        /\ s'.flag = s.flag;
    enabled(s, exit(i)) <=> 
        pindex(i);
    effect(s, exit(i), s') <=> 
           setPC(s, i, reset, s')
        /\ sameS(s, s')
	/\ samePCj(s, s')
	/\ s'.turn = s.turn
	/\ s'.flag = s.flag;
    enabled(s, crit(i)) <=> 
           pindex(i) /\ (s.p[i]).pc = leaveTry;
    effect(s, crit(i), s') <=> 
           setPC(s, i, crit, s')
        /\ sameS(s, s')
        /\ samePCj(s, s')
	/\ s'.turn = s.turn
	/\ s'.flag = s.flag;
    enabled(s, rem(i)) <=> 
       pindex(i) /\ (s.p[i]).pc = leaveExit;
    effect(s, rem(i), s') <=> 
           setPC(s, i, rem, s')
        /\ sameS(s, s')
        /\ samePCj(s, s')
	/\ s'.turn = s.turn
	/\ s'.flag = s.flag;
    enabled(s, setFlag1(i)) <=> 
        pindex(i) /\ (s.p[i]).pc = setFlag1;
    effect(s, setFlag1(i), s') <=> 
           setPC(s, i, testTurn, s')
        /\ sameS(s, s')
        /\ samePCj(s, s')
	/\ s'.turn = s.turn
	/\ setFlag(s, i, 1, s');
    enabled(s, testTurn(i)) <=> 
        pindex(i) /\ (s.p[i]).pc = testTurn;
    effect(s, testTurn(i), s') <=> 
	   setPC(s, i, (if s.turn = i then setFlag2 else testFlag), s')
	/\ setPCj(s, i, (if s.turn = i then 0 else s.turn), s')
        /\ sameS(s, s')
	/\ s'.turn = s.turn
	/\ s'.flag = s.flag;
    enabled(s, testFlag(i, k)) <=> 
        pindex(i) /\ (s.p[i]).pc = testFlag /\ (s.p[i]).pcJ = k;
    effect(s, testFlag(i, k), s') <=> 
           setPC(s, i, (if s.flag[k] = 0 then setTurn else testTurn), s')
        /\ sameS(s, s')
        /\ samePCj(s, s')
	/\ s'.turn = s.turn
	/\ s'.flag = s.flag;
    enabled(s, setTurn(i)) <=> 
        pindex(i) /\ (s.p[i]).pc = setTurn;
    effect(s, setTurn(i), s') <=> 
           setPC(s, i, setFlag2, s')
        /\ sameS(s, s')
        /\ samePCj(s, s')
	/\ s'.turn = i
	/\ setFlag(s, i, 1, s');
    enabled(s, setFlag2(i)) <=> 
        pindex(i) /\ (s.p[i]).pc = setFlag2;
    effect(s, setFlag2(i), s') <=> 
           setPC(s, i, check, s')
        /\ setS(s, i, {i}, s')
        /\ samePCj(s, s')
	/\ s'.turn = s.turn
	/\ setFlag(s, i, 2, s');
    enabled(s, check(i, k)) <=> 
        pindex(i) /\ (s.p[i]).pc = check /\ ~(k \in (s.p[i]).S);
    effect(s, check(i, k), s') <=> 
            setPC(s, i, (if s.flag[k] = 2 then setFlag1 
	      	         else if \A j (1 <= j /\ j <= n /\ j ~= k 
			                    => j \in (s.p[i]).S) then leaveTry
			 else check), s')
        /\ setS(s, i, if s.flag[k] = 2 then {} else insert(k, (s.p[i]).S), s')
        /\ samePCj(s, s')
	/\ s'.turn = s.turn
	/\ s'.flag = s.flag;
    enabled(s, reset(i)) <=> 
        pindex(i) /\ (s.p[i]).pc = reset;
    effect(s, reset(i), s') <=> 
           setPC(s, i, leaveExit, s')
	/\ setS(s, i, {}, s')
        /\ samePCj(s, s')
	/\ s'.turn = s.turn
	/\ setFlag(s, i, 0, s');
    %Innvariants
    mutex(s) <=> 
        \A i \A j (pindex(i) /\ pindex(j) =>
                      ~((s.p[i]).pc = crit /\ (s.p[j]).pc = crit /\ i ~= j));
    assertion2(s) <=> 
        \A i (pindex(i) /\ ((s.p[i]).pc = crit \/ (s.p[i]).pc = leaveTry) =>
                 \A j (pindex(j) => j \in (s.p[i]).S));

    assertion3(s) <=> 
        \A i \A j (       pindex(i) /\ pindex(j) /\ i ~= j
                       /\ (   (s.p[i]).pc = check 
		           \/ (s.p[i]).pc = leaveTry 
		           \/ (s.p[i]).pc = crit)
	               /\ (   (s.p[j]).pc = check 
		           \/ (s.p[j]).pc = leaveTry 
		           \/ (s.p[j]).pc = crit)
                   => ~(i \in (s.p[j]).S /\ j \in (s.p[i]).S));
    assertion4(s) <=> 
        \A i (       pindex(i)
                  /\ (   (s.p[i]).pc = check 
		      \/ (s.p[i]).pc = leaveTry
		      \/ (s.p[i]).pc = crit)
              => s.flag[i] = 2);
    inv(s) <=> 
      mutex(s) /\ assertion2(s) /\ assertion3(s) /\ assertion4(s)
  implies InductiveInv(A, inv)
