% Delayed implementation of lossy queue: crash marks 
% elements for deletion by subsequent internal actions

AutomatonD: trait
  includes IOAutomaton(D), MarkedMessages
  States[D] tuple of queue: Seq[Mmsg]
  introduces 
    insert, remove : Msg -> Actions[D]
    crash, lose    :     -> Actions[D]
  asserts 
    sort Actions[D] generated by insert, remove, crash, lose
    with s, s': States[D], m: Msg
      isExternal(insert(m));
      isExternal(remove(m));
      isExternal(crash);
      isInternal(lose);
      start(s)                 <=> isEmpty(s.queue);
      isStep(s, insert(m), s') <=> s'.queue = s.queue ^ [m, false];
      isStep(s, remove(m), s') <=>
        ~isEmpty(s.queue) /\ hd(s.queue).msg = m /\ s'.queue = tl(s.queue);
      isStep(s, crash, s')     <=> s'.queue = mark(s.queue);
      isStep(s, lose, s')      <=> subseqMarked(s'.queue, s.queue);
