% Simple specification of lossy queue: 
% crash deletes messages from queue

AutomatonS: trait
  includes IOAutomaton(S), Sequence(Msg)
  States[S] tuple of queue: Seq[Msg]
  introduces
    insert, remove : Msg -> Actions[S]
    crash          :     -> Actions[S]
  asserts 
    sort Actions[S] generated by insert, remove, crash
    with s, s': States[S], m: Msg
      isExternal(insert(m));
      isExternal(remove(m));
      isExternal(crash);
      start(s)                 <=> isEmpty(s.queue);
      isStep(s, insert(m), s') <=> s'.queue = s.queue ^ m;
      isStep(s, remove(m), s') <=>
        ~isEmpty(s.queue) /\ hd(s.queue) = m /\ s'.queue = tl(s.queue);
      isStep(s, crash, s')     <=> subseq(s'.queue, s.queue);
