SequenceMap (E1, E2, eMap, sMap): trait
  % This trait defines the function sMap: Seq[E1] -> Seq[E2] to be a pointwise
  % extension of the function eMap: E1 -> E2.
  includes Sequence(E1), Sequence(E2)
  introduces 
    eMap : E1      -> E2
    sMap : Seq[E1] -> Seq[E2]
  asserts with e: E1, s: Seq[E1]
    sMap(empty) = empty;
    sMap(s ^ e) = sMap(s) ^ eMap(e)
  implies \forall e: E1, s: Seq[E1]
    sMap(e ^ s) = eMap(e) ^ sMap(s);
    sMap(tl(s)) = tl(sMap(s));
    sMap(init(s)) = init(sMap(s));
    isEmpty(sMap(s)) <=> isEmpty(s);
    ~isEmpty(s) => eMap(hd(s)) = hd(sMap(s));
    ~isEmpty(s) => eMap(last(s)) = last(sMap(s));
    ~isEmpty(s) => eMap(hd(s)) ^ tl(sMap(s)) = sMap(s);
    ~isEmpty(s) => init(sMap(s)) ^ eMap(last(s)) = sMap(s)
