AuxDist : trait

includes TotalOrder(Ballot), TotalOrder(Node), Set(Ballot), Array(Node, Set[Ballot]), Set(Node), Integer, Set(Set[Node])

Ballot tuple of seqno : Int, procid : Node

introduces
  dummyNode : -> Node,
  dummyValue : -> Value,
  dummyBallot : -> Ballot,
  minBallot : -> Ballot,
  __<__ : Ballot, Ballot -> Bool,
  __<__ : Node, Node -> Bool,
  wquorums :  -> Set[Set[Node]],
  rquorums :  -> Set[Set[Node]],
  dead : Array[Node, Set[Ballot]] -> Set[Ballot],
  haveRQuorum : Array[Node, Set[Ballot]], Ballot -> Bool,
  haveWQuorum : Array[Node, Set[Ballot]], Ballot -> Bool,
  haveQuorum : Array[Node, Set[Ballot]], Ballot -> Bool
  haveNobody : Array[Node, Set[Ballot]], Ballot -> Bool

asserts with 
abstained, abs1, abs2 : Array[Node, Set[Ballot]], 
q_DeadQuorum, q_WQuorum, q_RQuorum : Set[Node],
b_Dead, b_NotMin : Ballot, 
n_Quorum, n_rQuorum, n_wQuorum, n_Dead : Node,
voted : Array[Node, Set[Ballot]],
b_Less, b_Greater : Ballot



  b_Less < b_Greater <=> (b_Less.seqno < b_Greater.seqno \/ (b_Less.seqno = b_Greater.seqno /\ b_Less.procid < b_Less.procid));

  b_Less = b_Greater <=> (b_Less.seqno = b_Greater.seqno /\ b_Less.procid = b_Greater.procid);
%  (b_Less.seqno = b_Greater.seqno /\ b_Less.procid = b_Greater.procid) <=> b_Less = b_Greater;

  \A q_RQuorum (\A q_WQuorum ((q_RQuorum \in rquorums /\ q_WQuorum \in wquorums) => \E n_Quorum : Node (n_Quorum \in (q_RQuorum \I q_WQuorum))));

  \A q_RQuorum  (q_RQuorum \in rquorums => (\E n_wQuorum : Node (n_wQuorum \in q_RQuorum)));

  \A q_WQuorum (q_WQuorum \in wquorums => (\E n_rQuorum : Node (n_rQuorum \in q_WQuorum)));



  b_Dead \in dead (abstained)  <=> \E q_DeadQuorum  ((q_DeadQuorum \in rquorums) /\ \A n_Dead : Node (n_Dead \in q_DeadQuorum => b_Dead \in abstained[n_Dead]));

  \A n_Dead : Node (abs1[n_Dead] \subseteq abs2[n_Dead] => dead(abs1) \subseteq dead(abs2));



  \A b_NotMin (b_NotMin ~= minBallot => minBallot < b_NotMin);




