AuxMQ : trait

includes TotalOrder(Ballot), Set(Ballot), Array(Node, Set[Ballot]), Set(Node)

introduces
  dummyNode : -> Node,
  dummyValue : -> Value,
  dummyBallot : -> Ballot,
  minBallot : -> Ballot,
  __<__ : Ballot, Ballot -> Bool,
  wquorums : Ballot -> Set[Node],
  rquorums : Ballot -> Set[Node],
  dead : Array[Node, Set[Ballot]] -> Set[Ballot],
  haveRQuorum : Array[Node, Set[Ballot]], Ballot -> Bool,
  haveWQuorum : Array[Node, Set[Ballot]], Ballot -> Bool,
  haveQuorum : Array[Node, Set[Ballot]], Ballot -> Bool
  haveNobody : Array[Node, Set[Ballot]], Ballot -> Bool

asserts with 
abstained : Array[Node, Set[Ballot]], b_WQuorum, b_RQuorum, 
b_DeadQuorum, b_Dead, b_NotMin : Ballot, 
n_Quorum, n_rQuorum, n_wQuorum, n_Dead : Node,
voted : Array[Node, Set[Ballot]],
b_HaveWQuorum, b_qHaveWQuorum : Ballot,
n_HaveWQuorum : Node,
b_HaveRQuorum, b_qHaveRQuorum : Ballot,
n_HaveRQuorum : Node,
b_HaveQuorum, b_qHaveQuorum : Ballot,
n_HaveQuorum : Node,
a_HaveQuorum : Array[Node, Set[Ballot]],
a_HaveWQuorum : Array[Node, Set[Ballot]],
a_HaveRQuorum : Array[Node, Set[Ballot]]

  \A b_RQuorum (\A b_WQuorum (\E n_Quorum : Node (n_Quorum \in (rquorums(b_RQuorum) \I wquorums(b_WQuorum)))));

  \A b_RQuorum  (\E n_wQuorum : Node (n_wQuorum \in (rquorums(b_RQuorum))));

  \A b_WQuorum (\E n_rQuorum : Node (n_rQuorum \in (wquorums(b_WQuorum))));



  b_Dead \in dead (abstained)  <=> \E b_DeadQuorum  (\A n_Dead : Node (n_Dead \in rquorums(b_DeadQuorum) => b_Dead \in abstained[n_Dead]));


  \A b_NotMin (b_NotMin ~= minBallot => minBallot < b_NotMin);


  haveWQuorum (a_HaveWQuorum, b_HaveWQuorum) <=> \E b_qHaveWQuorum (\A n_HaveWQuorum (n_HaveWQuorum \in wquorums(b_qHaveWQuorum) => b_HaveWQuorum \in a_HaveWQuorum[n_HaveWQuorum]));

  haveNobody (a_HaveQuorum, b_HaveQuorum) <=> (\A n_HaveQuorum ~(b_HaveQuorum \in a_HaveQuorum[n_HaveQuorum]));


  haveRQuorum (a_HaveRQuorum, b_HaveRQuorum) <=> \E b_qHaveRQuorum (\A n_HaveRQuorum (n_HaveRQuorum \in rquorums(b_qHaveRQuorum) => b_HaveRQuorum \in a_HaveRQuorum[n_HaveRQuorum]))






