(*  Title:      HOL/IOA/Asig.thy
    ID:         $Id: Array.thy,v 1.1 2003/08/04 09:44:48 tohn Exp $
    Author:     Stephen J. Garland
    Copyright   1994  TU Muenchen

IOA Arrays
*)
theory Array = Main :

types ('a, 'b) Array = "'a => 'b"

consts
  sub :: "[('a, 'b) Array, 'a] => 'b"      ("_ [ _ ]")

defs
  sub_def[simp] : "sub x y == x y"

consts 
  constant :: "'b => ('a, 'b) Array"

defs
  constant_def[simp] : "constant(x) y == x"

(* lemma
  const_sub_lemma : "(sub (constant x) y) = x"
*)

consts
  assign :: "[('a, 'b) Array, 'a, 'b] => ('a, 'b) Array"


defs
  assign_def[simp] : "(assign a b c d) == if b = d then c else a(d)"

lemma sub_new: "sub (assign A d1 r1) d1 = r1"
  by(simp add: sub_def assign_def)

lemma sub_old: "sub A d1 = r1 & d1 ~= d2 ==> sub (assign A d2 r2) d1 = r1"
  by (simp add: sub_def assign_def, blast)



end
