Set(E): trait
  includes Integer
  introduces
    {}:                           -> Set[E]     % empty set
    {__}:          E              -> Set[E]     % singleton set
    insert:        E, Set[E]      -> Set[E]     % insert element
    delete:        E, Set[E]      -> Set[E]     % delete element
    empty:         Set[E]         -> Bool
    __\in __:       E, Set[E]      -> Bool       % membership
    __\U __, __\I __,                             % union, intersection
    __-__:         Set[E], Set[E] -> Set[E]     % difference
    __\subset __,                                % proper subset
    __\supset __,                                % proper superset
    __\subseteq __,                              % subset
    __\supseteq __: Set[E], Set[E] -> Bool       % superset
    size:          Set[E]         -> Int        % size of set
  asserts with s, s1, s2: Set[E], e, e1, e2: E
    \A e (e \in s1 <=> e \in s2) <=> s1 = s2;
    {e} = insert(e, {});
    ~(e \in {});
    e1 \in insert(e2, s) <=> e1 = e2 \/ e1 \in s;
    e1 \in delete(e2, s) <=> e1 ~= e2 /\ e1 \in s;
    e1 \in insert(e1, s);
    ~(e1 \in delete(e1, s));
    e \in (s1 \U s2) <=> e \in s1 \/ e \in s2;
    e \in (s1 \I s2) <=> e \in s1 /\ e \in s2;
    s = {} <=> \A e ~(e \in s);
    e \in (s1 - s2) <=> e \in s1 /\ ~(e \in s2);
    s1 \subseteq s2 <=> \A e (e \in s1 => e \in s2);
    s1 \supset s2 <=> s2 \subset s1;
    %s1 \subset s2 <=> s1 \subseteq s2 /\ s1 ~= s2;
    s1 \subseteq s2 <=> s1 = s2 \/ s1 \subset s2;

    size({}) = 0;
    size(insert(e, s)) = size(s) + (if e \in s then 0 else 1);
    size(s) = size(delete(e, s)) + (if e \in s then 1 else 0);
    s1 \U {} = s1;
    s1 \I {} = {};
    delete (e, s) \subseteq s;
    s \subseteq insert(e, s);
    empty({});
    \E e (e \in s) <=> ~empty(s);
    s = {} <=> empty(s);
    size(s) = 0 <=> empty(s);


%  asserts
%     sort Set[E] generated by {}, insert

