BinaryTree(E): trait
  % Standard binary tree, without the existence of NULL objects
  introduces
    makeTreeNoChild:    E		   -> Tree[E]
    makeTreeLeftChild:	E, Tree[E]	   -> Tree[E]
    makeTreeRightChild:	E, Tree[E]	   -> Tree[E]
    makeTreeTwoChild:	E, Tree[E], Tree[E]-> Tree[E]	

    content:      	Tree[E]             -> E
    left, right:   	Tree[E]             -> Tree[E]
    hasLeft, hasRight: 	Tree[E]		    -> Bool
    isLeaf:        	Tree[E]             -> Bool

  asserts with e: E, t1, t2: Tree[E]
    sort Tree[E] generated by makeTreeNoChild, makeTreeLeftChild, makeTreeRightChild, makeTreeTwoChild;
    sort Tree[E] partitioned by content, left, right, hasLeft, hasRight, isLeaf;
    content(makeTreeNoChild(e)) = e;
    content(makeTreeLeftChild(e, t1)) = e;
    content(makeTreeRightChild(e, t2)) = e;
    content(makeTreeTwoChild(e, t1, t2)) = e;

    left(makeTreeLeftChild(e, t1)) = t1;
    left(makeTreeTwoChild(e, t1, t2)) = t1;

    right(makeTreeRightChild(e, t2)) = t2;
    right(makeTreeTwoChild(e, t1, t2)) = t2;

    ~hasLeft(makeTreeNoChild(e));
    hasLeft(makeTreeLeftChild(e, t1));
    ~hasLeft(makeTreeRightChild(e, t2));
    hasLeft(makeTreeTwoChild(e, t1, t2));

    ~hasRight(makeTreeNoChild(e));
    ~hasRight(makeTreeLeftChild(e, t1));
    hasRight(makeTreeRightChild(e, t2));
    hasRight(makeTreeTwoChild(e, t1, t2));

    isLeaf(makeTreeNoChild(e));
    ~isLeaf(makeTreeLeftChild(e, t1));
    ~isLeaf(makeTreeRightChild(e, t2));
    ~isLeaf(makeTreeTwoChild(e, t1, t2));

  implies converts isLeaf, hasLeft, hasRight, content





