Graph(N, G): trait
  % n1 \< g \> n2 means that there is an edge from n1 to n2 in g.
  includes Relation(N for E, G for Rel[E])
  introduces
    nodes, undirected: G -> G
    isPath: N, N, G -> Bool
    stronglyConnected, weaklyConnected: G -> Bool
  asserts with n1, n2: N, g: G
    undirected(g) = g \U (g\inv);
    nodes(g) = dom(g) \U range(g);
    isPath(n1, n2, g) <=> n1 \< g\superstar \> n2;
    stronglyConnected(g) <=> g\superstar = nodes(g) \times nodes(g);
    weaklyConnected(g) <=> stronglyConnected(undirected(g))
  implies with n1, n2: N, g: G
    stronglyConnected(g) /\ n1 \in nodes(g) /\ n2 \in nodes(g)
      => isPath(n1, n2, g)
