IntCycle(N, first, last): trait
  % A finite subrange of the integers that includes 0, 
  % contains at least two integers, and wraps at succ(last).
  includes
    ArithOps(N),
    DecimalLiterals(N),
    MinMax(N),
    TotallyOrdered(N)
  introduces
    first, last:         -> N
    pred, -__, abs: N    -> N
    __-__:          N, N -> N
  asserts with i, j: N
    sort N generated by 0, succ;
    last ~= 0;
    succ(last) = first;
    succ(i) = succ(j) <=> i = j;
    i ~= last => i < succ(i);
    pred(succ(i)) = i;
    -0 = 0;
    -succ(i) = pred(-i);
    abs(i) = (if i < 0 then -i else i);
    i - j = i + (-j)
  implies with i, j: N
    traits Distributive(N, +, *), RingWithUnit(N for T);
    sort N generated by 0, pred;
    pred(first) = last;
    succ(pred(i)) = i;
    pred(i) = pred(j) <=> i = j;
    i ~= first => pred(i) < i;
    first <= i;
    i <= last;
    ~(i < first);
    ~(i > last);
    -(-i) = i;
    i - i = 0;
    converts pred, -__, abs, __-__, 1, +, *, max, min, <=, >=, <, >
