List(E): trait
  % Common operators on lists, formalized as double ended queues.
  introduces
    empty:                       -> List[E]
    {__}:       E                -> List[E]
    __-|__:     E, List[E]       -> List[E]
    __|-__:     List[E], E       -> List[E]
    __||__:     List[E], List[E] -> List[E]
    head, last: List[E]          -> E
    tail, init: List[E]          -> List[E]
  asserts with e, e1, e2: E, ls, ls1, ls2: List[E]
    sort List[E] generated freely by empty, |-;
    {e} = empty |- e;
    empty |- e = e -| empty;
    (e1 -| ls) |- e2 = e1 -| (ls |- e2);
    empty || ls = ls;
    (e -| ls1) || ls2 = e -| (ls2 || ls2);
    head(e -| ls) = e;
    last(ls |- e) = e;
    tail(e -| ls) = ls;
    init(ls |- e) = ls;
  implies with e: E, ls, ls1, ls2: List[E]
    sort List[E] generated freely by empty, -|;
    sort List[E] generated by empty, {__}, ||;
    ls ~= empty =>  head(ls) -| tail(ls) = ls /\ init(ls) |- last(ls) = ls;
    ls1 || (ls2 |- e) = (ls1 || ls2) |- e;
    converts {__}, |-, ||, head, last, tail, init
      exempting head(empty), last(empty), tail(empty), init(empty)
