RelationOps: trait
  % Useful non-primitive operators on relations.
  assumes RelationBasics
  includes DerivedOrders(Rel[E], \subset, \subseteq, \supset, \supseteq)
  introduces
    __\in__, __\notin__:                         E, Rel[E]      -> Bool
    set, dom, range, __\superplus, __\superstar: Rel[E]         -> Rel[E]
    __\I__, __\circ__, __-__, __\times__:        Rel[E], Rel[E] -> Rel[E]
    domRestrict, rangeRestrict, image:           Rel[E], Rel[E] -> Rel[E]
  asserts with e, e1, e2, e3: E, r, r1, r2: Rel[E]
    e \in r <=> e \<r\> e;
    e \notin r <=> ~(e \in r);
    set(r) = r \I I;
    dom(r) = set(r \circ \top);
    range(r) = set(\top \circ r);
    e1\<r1 \I r2\>e2 <=> e1\<r1\>e2 /\ e1\<r2\>e2;
    e1\<r1\>e2 /\ e2\<r2\>e3 => e1\<r1 \circ r2\>e3;
    e1\<r1 \circ r2\>e3 => \E e2(e1\<r1\>e2 /\ e2\<r2\>e3);
    r\superplus = r \circ (r\superstar);
    r\superstar = I \U (r\superplus);
    r1 = I \U r2 /\ r2 = r \circ r1 => 
      (r\superstar) \subseteq r1 /\ (r\superplus) \subseteq r2;
    r1 - r2 = r1 \I (-r2);
    r1 \times r2 = (set(r1) \circ \top) \circ set(r2);
    r1 \subseteq r2 <=> r1 - r2 = \bot;
    domRestrict(r1, r2) = r1 \I (r2 \circ \top);
    image(r1, r2) = set(r1) \circ r2;
    rangeRestrict(r1, r2) = r1 \I (\top \circ r2)
  implies with e: E, r, r1, r2: Rel[E]
    traits AbelianMonoid(Rel[E], \I, \top),
           Distributive(Rel[E], \U, \I),
           Distributive(Rel[E], \I, \U),
           Idempotent(Rel[E], set),
           Monoid(Rel[E], \circ, I),
           Lattice(Rel[E], \U for \lub, \I for \glb,
                   \subseteq for <=, \supseteq for >=, \subset for <, 
                   \supset for >),
           PartiallyOrdered(Rel[E], \subset, \subseteq, \supset, \supseteq);
    e \in r <=> e \in set(r);
    -(r1 \U r2) = (-r1) \I (-r2);
    -(r1 \I r2) = (-r1) \U (-r2);
    (r1 \circ r2)\inv = (r2\inv) \circ (r1\inv);
    converts
      \in, \notin, set, dom, range, __\superplus, __\superstar, __-__, \times,
      \U, \I, \circ, -__, \inv, \subseteq, \supseteq, \subset, \supset, 
      domRestrict, image, rangeRestrict
