SequenceOps(E): trait
  includes Sequence(E), 
           DerivedOrders(Seq[E], \subset, \subseteq, \supset, \supseteq)
  introduces 
    prefix, suffix:            Seq[E], Int      -> Seq[E]
    subseq:                    Seq[E], Int, Int -> Seq[E]
    isPrefix, isSuffix, 
      isSubseq, __\subseteq__: Seq[E], Seq[E]   -> Bool
    find:                      E, Seq[E]        -> Int
    find:                      Seq[E], Seq[E]   -> Int
  asserts with e, e1, e2: E, s, s1, s2: Seq[E], i, n: Int
    prefix(s, 0) = {};
    n >= 0 => prefix(e -| s, n + 1) = e -| prefix(s, n);
    isPrefix(s1, s2) <=> s1 = prefix(s2, len(s1));
    suffix(s, 0) = s;
    n >= 0 => suffix(s, n + 1) = suffix(tail(s), n);
    isSuffix(s1, s2) <=> 
      len(s1) <= len(s2) /\ s1 = suffix(s2, len(s2) - len(s1));
    subseq(s, 0, n) = prefix(s, n);
    i >= 0 => subseq(s, i + 1, n) = subseq(tail(s), i, n);
    isSubseq(s1, s2) <=> isPrefix(s1, s2) \/ isSubseq(s1, tail(s2));
    {} \subseteq s;
    ~((e -| s) \subseteq {});
    (e1 -| s2) \subseteq (e2 -| s2) 
      <=> (e1 = e2 /\ s1 \subseteq s2) \/ (e1 -| s1) \subseteq s2;
    find(e, e1 -| s) = (if e = e1 then 1 else find(e, s) + 1);
    find(s1, s2) = (if isPrefix(s1, s2) then 1 else find(s1, tail(s2)) + 1)
  implies with s, s1, s2: Seq[E], e: E, i, n: Int
    traits PartialOrder(Seq[E], isPrefix),
           PartialOrder(Seq[E], isSubseq),
           PartialOrder(Seq[E], \subseteq);
    isPrefix(prefix(s, n), s);
    isSubseq(subseq(s, i, n), s);
    isSubseq(s1, s2) => s1 \subseteq s2;
    converts isPrefix, isSubseq, \subset, \subseteq, \supset, \supseteq, 
             find:E,Seq[E]->Int, find:Seq[E],Seq[E]->Int
      exempting find(e, {}), find(e -| s, {})
