Set(E): trait
  % Common set operators
  includes
    SetBasics, 
    Integer,
    DerivedOrders(Set[E], \subset, \subseteq, \supset, \supseteq)
  introduces
    __\notin__:            E, Set[E]      -> Bool
    delete:                E, Set[E]      -> Set[E]
    {__}:                  E              -> Set[E]
    __\U__, __\I__, __-__: Set[E], Set[E] -> Set[E]
    size:                  Set[E]         -> Int
  asserts with e, e1, e2: E, s, s1, s2: Set[E]
    e \notin s <=> ~(e \in s);
    {e} = insert(e, {});
    e1 \in delete(e2, s) <=> e1 ~= e2 /\ e1 \in s;
    e \in (s1 \U s2) <=> e \in s1 \/ e \in s2;
    e \in (s1 \I s2) <=> e \in s1 /\ e \in s2;
    e \in (s1 - s2)  <=> e \in s1 /\ e \notin s2;
    size({}) = 0;
    size(insert(e, s)) = size(s) + (if e \in s then 0 else 1);
    s1 \subseteq s2 <=> s1 - s2 = {}
  implies with e: E, s, s1, s2: Set[E]
    traits AbelianMonoid(Set[E], \U, {}), 
           AC(Set[E], \I),
           JoinOp(E, Set, \U, {} for empty),
           MemberOps(E, Set, {} for empty),
           PartialOrder(Set[E], \subseteq);
    sort Set[E] generated by {}, {__}, \U;
    s1 \subseteq s2 <=> \A e (e \in s1 => e \in s2);
    converts
      \in, \notin, {__}, delete, \U, \I, -:Set[E],Set[E]->Set[E],
      \subseteq, \supseteq, \subset, \supset
