PriorityMinQueue(E, <:E,E->Bool): trait
  % Enumerates by order on elements.
  assumes TotallyOrdered(E)
  includes Count(E, PMQ, empty, add, count), 
           Size(E, PMQ, empty, add, len)
  introduces
    empty:            -> PMQ[E]
    add:     E, PMQ[E] -> PMQ[E]
    __\in__: E, PMQ[E] -> Bool
    head:    PMQ[E]    -> E
    tail:    PMQ[E]    -> PMQ[E]
    isEmpty: PMQ[E]    -> Bool
  asserts with e, e1: E, q: PMQ[E]
    sort PMQ[E] generated by empty, add;
    sort PMQ[E] partitioned by head, tail, isEmpty;
    e \in q <=> count(e, q) > 0;
    head(add(e, q)) =
      (if q = empty \/ e < head(q) then e else head(q));
    tail(add(e, q)) =
      (if q = empty \/ e < head(q) then q else add(e, tail(q)));
    isEmpty(q) <=> q = empty
  implies with e, e1, e2: E, q: PMQ[E]
    traits Container(E, PMQ, empty, add);
    add(e1, add(e2, q)) = add(e2, add(e1, q));
    add(e, q) ~= empty;
    converts count, \in, head, tail, len, isEmpty
      exempting head(empty), tail(empty)

